/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the SignatureRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SignatureRequest{}

// SignatureRequest struct for SignatureRequest
type SignatureRequest struct {
	Mode string `json:"mode"`
	ContactId string `json:"contact_id"`
	TemplateId string `json:"template_id"`
	TransactionId string `json:"transaction_id"`
	ConversationId string `json:"conversation_id"`
	GatewayId string `json:"gateway_id"`
	SessionName string `json:"session_name"`
	Data DocumentData `json:"data"`
	MessengerId string `json:"messenger_id"`
	MessengerType string `json:"messenger_type"`
	OrganizationId string `json:"organization_id"`
	ChannelId string `json:"channel_id"`
}

// NewSignatureRequest instantiates a new SignatureRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSignatureRequest(mode string, contactId string, templateId string, transactionId string, conversationId string, gatewayId string, sessionName string, data DocumentData, messengerId string, messengerType string, organizationId string, channelId string) *SignatureRequest {
	this := SignatureRequest{}
	this.Mode = mode
	this.ContactId = contactId
	this.TemplateId = templateId
	this.TransactionId = transactionId
	this.ConversationId = conversationId
	this.GatewayId = gatewayId
	this.SessionName = sessionName
	this.Data = data
	this.MessengerId = messengerId
	this.MessengerType = messengerType
	this.OrganizationId = organizationId
	this.ChannelId = channelId
	return &this
}

// NewSignatureRequestWithDefaults instantiates a new SignatureRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSignatureRequestWithDefaults() *SignatureRequest {
	this := SignatureRequest{}
	return &this
}

// GetMode returns the Mode field value
func (o *SignatureRequest) GetMode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Mode
}

// GetModeOk returns a tuple with the Mode field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetModeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Mode, true
}

// SetMode sets field value
func (o *SignatureRequest) SetMode(v string) {
	o.Mode = v
}

// GetContactId returns the ContactId field value
func (o *SignatureRequest) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *SignatureRequest) SetContactId(v string) {
	o.ContactId = v
}

// GetTemplateId returns the TemplateId field value
func (o *SignatureRequest) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *SignatureRequest) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetTransactionId returns the TransactionId field value
func (o *SignatureRequest) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *SignatureRequest) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetConversationId returns the ConversationId field value
func (o *SignatureRequest) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *SignatureRequest) SetConversationId(v string) {
	o.ConversationId = v
}

// GetGatewayId returns the GatewayId field value
func (o *SignatureRequest) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *SignatureRequest) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetSessionName returns the SessionName field value
func (o *SignatureRequest) GetSessionName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SessionName
}

// GetSessionNameOk returns a tuple with the SessionName field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetSessionNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SessionName, true
}

// SetSessionName sets field value
func (o *SignatureRequest) SetSessionName(v string) {
	o.SessionName = v
}

// GetData returns the Data field value
func (o *SignatureRequest) GetData() DocumentData {
	if o == nil {
		var ret DocumentData
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetDataOk() (*DocumentData, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Data, true
}

// SetData sets field value
func (o *SignatureRequest) SetData(v DocumentData) {
	o.Data = v
}

// GetMessengerId returns the MessengerId field value
func (o *SignatureRequest) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *SignatureRequest) SetMessengerId(v string) {
	o.MessengerId = v
}

// GetMessengerType returns the MessengerType field value
func (o *SignatureRequest) GetMessengerType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerType
}

// GetMessengerTypeOk returns a tuple with the MessengerType field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetMessengerTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerType, true
}

// SetMessengerType sets field value
func (o *SignatureRequest) SetMessengerType(v string) {
	o.MessengerType = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *SignatureRequest) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *SignatureRequest) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetChannelId returns the ChannelId field value
func (o *SignatureRequest) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *SignatureRequest) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *SignatureRequest) SetChannelId(v string) {
	o.ChannelId = v
}

func (o SignatureRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SignatureRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["mode"] = o.Mode
	toSerialize["contact_id"] = o.ContactId
	toSerialize["template_id"] = o.TemplateId
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["session_name"] = o.SessionName
	toSerialize["data"] = o.Data
	toSerialize["messenger_id"] = o.MessengerId
	toSerialize["messenger_type"] = o.MessengerType
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["channel_id"] = o.ChannelId
	return toSerialize, nil
}

type NullableSignatureRequest struct {
	value *SignatureRequest
	isSet bool
}

func (v NullableSignatureRequest) Get() *SignatureRequest {
	return v.value
}

func (v *NullableSignatureRequest) Set(val *SignatureRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSignatureRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSignatureRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSignatureRequest(val *SignatureRequest) *NullableSignatureRequest {
	return &NullableSignatureRequest{value: val, isSet: true}
}

func (v NullableSignatureRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSignatureRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


